zoukankan      html  css  js  c++  java
  • 【15.93%】【codeforces 672D】Robin Hood

    time limit per test1 second
    memory limit per test256 megabytes
    inputstandard input
    outputstandard output
    We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

    There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest’s 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

    After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

    Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn’t affect the answer.

    Input
    The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood’s retirement.

    The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

    Output
    Print a single line containing the difference between richest and poorest peoples wealth.

    Examples
    input
    4 1
    1 1 4 2
    output
    2
    input
    3 1
    2 2 2
    output
    0
    Note
    Lets look at how wealth changes through day in the first sample.

    [1, 1, 4, 2]
    [2, 1, 3, 2] or [1, 2, 3, 2]
    So the answer is 3 - 1 = 2

    In second sample wealth will remain the same for each person.

    【题解】

    最后变成一样的话->平均数;
    小于平均数的要增大。
    大于平均数的要减小。
    二分获取最后的最小值的最大值以及最大值的最小值;
    ->判断一个数字可不可行的依据
    ->比如获取最小值的最大值
    ->看比当前的值小的值需要增加多少
    ->小于等于k->可行
    ->否则不可行
    不断逼近那个k;
    最后获取答案=maxmin-minmax
    但是要注意;
    如果∑c[i] % n !=0 则最后答案是不可能相等的。因此如果求出来等于0
    是因为用来枚举的右端点和左端点一样了;
    因此把答案直接改成1;
    ->∑c[i]%n==0的话最后是肯定都能变成一样的。
    多想想吧
    如果想加快速度。可以把数组排下序。
    用个lower_bound什么的快速检索比它大的
    ->再用个前缀和什么的就更完美了;

    #include <cstdio>
    #include <cmath>
    #include <iostream>
    #include <algorithm>
    #include <cstring>
    #include <queue>
    #include <vector>
    #include <stack>
    #define LL long long
    
    using namespace std;
    
    const int MAXN = 6e5;
    const int INF = 2100000000;
    
    struct dingxiao
    {
        int adj;
        int val;
        friend  bool operator<(dingxiao a, dingxiao b) { return  a.val > b.val; }
    };
    
    struct dingda
    {
        int adj;
        int val;
        friend  bool operator<(dingda a, dingda b) { return  a.val < b.val; }
    };
    
    priority_queue<dingxiao>Qdingxiao;
    priority_queue<dingda>Qdingda;
    
    int n, k;
    int c[MAXN];
    
    void input(int &r)
    {
        r = 0;
        char t = getchar();
        while (!isdigit(t)) t = getchar();
        int sign = 1;
        if (t == '-')sign = -1;
        while (!isdigit(t)) t = getchar();
        while (isdigit(t)) r = r * 10 + t - '0', t = getchar();
        r = r*sign;
    }
    
    int main()
    {
        //freopen("F:\rush.txt", "r", stdin);
        input(n); input(k);
        LL sum = 0;
        for (int i = 1; i <= n; i++)
            input(c[i]),sum+=c[i];
        LL average = sum / n;
        LL l = 0, r = average;
        LL minmax;
        while (l <= r)
        {
            LL mid = (l + r) >> 1;
            LL kk = 0;
            for (int i = 1;i <= n;i++)
                if (c[i] < mid)
                    kk += mid - c[i];
            if (kk <= k)
                minmax = mid, l = mid + 1;
            else
                r = mid - 1;
        }
        l = average, r = INF;
        LL maxmin;
        while (l <= r)
        {
            LL mid = (l + r) >> 1;
            LL kk = 0;
            for (int i = 1; i <= n; i++)
                if (mid < c[i])
                    kk += c[i] - mid;
            if (kk <= k)
                maxmin = mid, r = mid - 1;
            else
                l = mid + 1;
        }
        LL ans = maxmin - minmax;
        if (!ans)
            if (sum%n)
                ans = 1;
        printf("%I64d
    ", ans);
        return 0;
    }
  • 相关阅读:
    什么是Redis?
    请写出常用的linux指令
    Maven常用命令有哪些?
    Maven的工程类型有哪些?
    Maven仓库是什么
    什么是Maven?
    Shiro 的优点
    比较 SpringSecurity 和 Shiro
    判断x二进制编码中1的个数的奇偶性
    寻找600851475143的最大素因子的快速算法
  • 原文地址:https://www.cnblogs.com/AWCXV/p/7632125.html
Copyright © 2011-2022 走看看